Unit ZF30R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF30R(F :Func_F2; N :Integer; var EPS :Real; NDIG :Integer;
                var ITMAX :Integer; var ROOT :Array of Real;
                var RAB :Array of Real; var IERR :Integer);

implementation

procedure ZF30R(F :Func_F2; N :Integer; var EPS :Real; NDIG :Integer;
                var ITMAX :Integer; var ROOT :Array of Real;
                var RAB :Array of Real; var IERR :Integer);
var
I,I1,IP,IPK,IPJ,IPART,IPARTK,IPARTI,IERROR,IT,ITMP,ITMPI,ITEMP,ITEST,
   IJ,ISUB,ISUB1,IQUIT,IKBUS,J,JJ,JTEST,JPOINT,JS1,JSUB,N2,NSIG,M,M1,
   MM,MMN,K,K1,KK,KN,KL,KMIN,KMAX,KPOINT,KPLUS,L,L1,LK,LKSUB,LKSUBI,
   LKSUBJ,LKSUBK,LKMAX,LKJSUB,LOOK,LIM :Integer;
E,ETA,FMAX,FPLUS,RELCON,DERMAX,XTEMP,TOP,TEST,H,HOLD :Real;
const
PREC :Real = 5.0E-7;
DELTA :Real = 5.0E-5;
ZERO :Real = 0.0E0;
PM1 :Real = 0.1E0;
PT1 :Real = 0.0001E0;
P2 :Real = 0.002E0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48;
begin
IERR := 0;
EPS := Abs(EPS);
NSIG := NDIG;
N2 := N+N;
if ( NDIG = 0 ) and ( EPS = 0.0 ) 
 then NSIG := 5;
RELCON := Power(10.E+0,-NSIG);
JTEST := 1;
IERROR := 0;
IPART := ((N+2)*(N-1)) div 2;
ITMP := IPART+N;
LKSUB := ITMP+N;
for M:=1 to ITMAX do
 begin
  IQUIT := 0;
  FMAX := ZERO;
  M1 := M-1;
  K1 := LKSUB+1;
  KMIN := LKSUB+N;
  XTEMP := ZERO;
  for J:=K1 to KMIN do
   begin
    XTEMP := XTEMP+1.E0;
    RAB[J-1] := XTEMP;
_1:
   end;
  K := 1;
_2:
  if ( K <= 1 ) 
   then goto _6;
  KMIN := K-1;
  KK := 1;
_3:
  for K1:=1 to KMIN do
   begin
    ISUB := K-K1;
    MM := ((ISUB-1)*(N2-ISUB)) div 2;
    LIM := N-ISUB;
    IKBUS := LKSUB+ISUB;
    KPOINT := Trunc( RAB[IKBUS-1]+PM1 );
    ISUB1 := ISUB-1;
    ROOT[KPOINT-1] := ZERO;
    for L1:=1 to LIM do
     begin
      JS1 := ISUB1+L1;
      LKJSUB := LKSUB+JS1+1;
      IJ := MM+JS1;
      JPOINT := Trunc( RAB[LKJSUB-1]+PM1 );
      ROOT[KPOINT-1] := ROOT[KPOINT-1]+RAB[IJ-1]*ROOT[JPOINT-1];
_4:
     end;
    MMN := MM+N;
    ROOT[KPOINT-1] := ROOT[KPOINT-1]+RAB[MMN-1];
_5:
   end;
  case KK of
   1: goto _6;
   2: goto _9;
   3: goto _21;
  end;
_6:
  E := F(ROOT,K);
  FMAX := EMax1(FMAX,Abs(E));
  if ( Abs(E) >= EPS ) 
   then goto _7;
  IQUIT := IQUIT+1;
  if ( IQUIT = N ) 
   then goto _28;
_7:
  I := K;
_8:
  IP := IPART+I;
  LKSUBI := LKSUB+I;
  ITEMP := Trunc( RAB[LKSUBI-1]+PM1 );
  HOLD := ROOT[ITEMP-1];
  ETA := 0.001E+00*Abs(HOLD);
  if ( Abs(HOLD) < PREC ) 
   then ETA := DELTA;
  H := EMin1(FMAX,ETA);
  if ( H < PREC ) 
   then H := PREC;
  ROOT[ITEMP-1] := HOLD+H;
  if ( K <= 1 ) 
   then goto _9;
  KK := 2;
  goto _3;
_9:
  FPLUS := F(ROOT,K);
  TOP := FPLUS-E;
  if ( Abs(TOP) >= PREC ) 
   then goto _10;
  RAB[IP-1] := ZERO;
  goto _11;
_10:
  RAB[IP-1] := TOP/H;
_11:
  ROOT[ITEMP-1] := HOLD;
  I := I+1;
  if ( I <= N ) 
   then goto _8;
  if ( K < N ) 
   then goto _12;
  IP := IPART+N;
  if ( Abs(RAB[IP-1]) = ZERO ) 
   then goto _16;
  ROOT[ITEMP-1] := -E/RAB[IP-1]+ROOT[ITEMP-1];
  goto _20;
_12:
  KL := LKSUB+K;
  LOOK := Trunc( RAB[KL-1]+PM1 );
  KMAX := LOOK;
  IP := IPART+K;
  DERMAX := Abs(RAB[IP-1]);
  KPLUS := K+1;
  for I:=KPLUS to N do
   begin
    IPARTI := IPART+I;
    TEST := Abs(RAB[IPARTI-1]);
    if ( TEST <= DERMAX ) 
     then goto _13;
    DERMAX := TEST;
    KMAX := I;
_13:
   end;
  if ( LOOK = KMAX ) 
   then goto _15;
  LKMAX := LKSUB+KMAX;
  RAB[KL-1] := RAB[LKMAX-1];
  RAB[LKMAX-1] := LOOK;
  IP := IPART+KMAX;
  XTEMP := RAB[IP-1];
  IPK := IPART+K;
  RAB[IP-1] := RAB[IPK-1];
  RAB[IPK-1] := XTEMP;
  if ( K < 2 ) 
   then goto _15;
  KMIN := K-1;
  I1 := 0;
  for I:=1 to KMIN do
   begin
    L := ((I1)*(N2-I)) div 2-1;
    J := L+KMAX;
    XTEMP := RAB[J-1];
    JJ := L+K;
    RAB[J-1] := RAB[JJ-1];
    RAB[JJ-1] := XTEMP;
    I1 := I;
_14:
   end;
_15:
  IPARTK := IPART+K;
  if ( Abs(RAB[IPARTK-1]) <> ZERO ) 
   then goto _18;
_16:
  if ( IERROR = 1 ) 
   then goto _27;
  for I:=1 to N do
   begin
    ROOT[I-1] := 0.9E0*ROOT[I-1]+0.12345E0;
_17:
   end;
  IERROR := 1;
  goto _21;
_18:
  L := ((K-1)*(N2-K)) div 2;
  KN := L+N;
  I1 := L-1;
  RAB[KN-1] := ZERO;
  IPK := IPART+K;
  for J:=KPLUS to N do
   begin
    LKSUBJ := LKSUB+J;
    JSUB := Trunc( RAB[LKSUBJ-1]+PM1 );
    JJ := I1+J;
    IPJ := IPART+J;
    RAB[JJ-1] := -RAB[IPJ-1]/RAB[IPK-1];
    RAB[KN-1] := RAB[KN-1]+RAB[IPJ-1]*ROOT[JSUB-1];
_19:
   end;
  LKSUBK := LKSUB+K;
  LK := Trunc( RAB[LKSUBK-1]+PM1 );
  RAB[KN-1] := (RAB[KN-1]-E)/RAB[IPK-1]+ROOT[LK-1];
  K := K+1;
  if ( K <= N ) 
   then goto _2;
_20:
  if ( N = 1 ) 
   then goto _21;
  KMIN := N-1;
  KK := 3;
  goto _3;
_21:
  if ( M <= 1 ) 
   then goto _24;
  if ( NSIG = 0 ) 
   then goto _23;
  for I:=1 to N do
   begin
    ITMPI := ITMP+I;
    if ( Abs(RAB[ITMPI-1]-ROOT[I-1]) > Abs(ROOT[I-1])*RELCON )
     then goto _23;
_22:
   end;
  JTEST := JTEST+1;
  if ( JTEST-3 ) < 0
   then goto _24
   else if ( JTEST-3 ) > 0
         then goto _28
         else goto _28;
_23:
  JTEST := 1;
_24:
  for I:=1 to N do
   begin
    ITMPI := ITMP+I;
    RAB[ITMPI-1] := ROOT[I-1];
_25:
   end;
_26:
 end;
M := ITMAX;
IERR := 65;
goto _48;
_27:
IERR := 66;
_28:
FMAX := ZERO;
TEST := 1.0E+15;
if ( N > 1 ) 
 then goto _29;
RAB[IPART+1] := F(ROOT,1);
FMAX := EMax1(FMAX,Abs(RAB[IPART+1]));
goto _31;
_29:
for I:=1 to N do
 begin
  IP := IPART+I;
  RAB[IP-1] := F(ROOT,I);
  FMAX := EMax1(FMAX,Abs(RAB[IP-1]));
_30:
 end;
_31:
K := 1;
for I:=1 to N do
 begin
  RAB[I-1] := ROOT[I-1];
  if ( Abs(ROOT[I-1]) > P2 ) 
   then goto _32;
  K := 2;
  RAB[I-1] := ZERO;
_32:
 end;
if ( K = 1 ) 
 then goto _39;
KK := 1;
goto _41;
_33:
if ( FMAX < TEST ) 
 then goto _38;
for I:=1 to N do
 begin
  ROOT[I-1] := RAB[I-1];
_34:
 end;
if ( N > 1 ) 
 then goto _35;
RAB[IPART+1] := RAB[ITMP+1];
goto _37;
_35:
for I:=1 to N do
 begin
  IPARTI := IPART+I;
  ITMPI := ITMP+I;
  RAB[IPARTI-1] := RAB[ITMPI-1];
_36:
 end;
_37:
FMAX := TEST;
_38:
K := 1;
_39:
ITEST := 0;
for I:=1 to N do
 begin
  RAB[I-1] := ROOT[I-1];
  if ( Abs(ROOT[I-1]) <= P2 ) 
   then goto _40;
  L := Trunc( ROOT[I-1]+PT1 );
  J := Trunc( ROOT[I-1]-PT1 );
  if ( L = J ) 
   then goto _40;
  RAB[I-1] := IntSign(1,J)*Max0(Abs(L),Abs(J));
  K := 2;
_40:
 end;
if ( K = 1 ) 
 then goto _47;
KK := 2;
_41:
TEST := ZERO;
if ( N > 1 ) 
 then goto _42;
RAB[ITMP+1] := F(RAB,1);
TEST := EMax1(TEST,Abs(RAB[ITMP+1]));
goto _44;
_42:
for I:=1 to N do
 begin
  IT := ITMP+I;
  RAB[IT-1] := F(RAB,I);
  TEST := EMax1(TEST,Abs(RAB[IT-1]));
_43:
 end;
_44:
case KK of
 1: goto _33;
 2: goto _45;
end;
_45:
if ( FMAX < TEST ) 
 then goto _47;
for I:=1 to N do
 begin
  ROOT[I-1] := RAB[I-1];
_46:
 end;
ITEST := 1;
_47:
if ( FMAX < EPS ) or ( TEST < EPS ) 
 then IERR := 0;
_48:
ITMAX := M1+1;
if ( IERR <> 0 ) 
 then UTZF10(IERR,30);
end;

end.
